/*
 * Le variabili seguenti vengono utilizzate per comporre la pagina di
 * gioco, inserendo informazioni come il nome dell'avventura, l'autore,
 * la versione ecc...
 */
var title = "Unknown title";
var author = "Unknown author";
var email = "Unknown e-mail";
var release = "0.0";
var copyright = "20XX";
var ln = "<br/><br/>";

//==============================================================================
// Libreria per la gestione di un'AT javascript

var currAction = 1;//action currently selected
var entities = new Array();//array of entities
var turn = 1;//viene incrementata ogni turno
var gameOver = false;//fine del gioco

function random(n) {
	return Math.ceil(n * Math.random());
}

/*
 * Costruttore di entit: associa ad
 * una parola la relativa funzione-entit.
 */
function Entity(name, func) {
	this.name = name;
	this.func = func;
}

/*
 * Inizializza la schermata di gioco vera e propria.
 */
function initGUI() {
	var html = "";
	html += "<blockquote>";
	html += "<center><h2>" + title + "</h2></center>";
	html += "<center>Un'avventura testuale di <a href=\"mailto:" + email + "?subject=[" + title + "]\">" + author + "</a> (c) " + copyright + "</center>";
	html += "<center>Release " + release + "</center>";
	html += "<br/><hr/>";
	html += "<table width=\"100%\">";
	html += "<tr>";
	html += "<td><input type=\"radio\" name=\"action\" id=\"examine\" value=\"1\" onclick=\"currAction=1\" checked=\"checked\"/>Esamina</td>";
	html += "<td><input type=\"radio\" name=\"action\" id=\"act\" value=\"2\" onclick=\"currAction=2\"/>Agisci</td>";
	html += "<td><input type=\"radio\" name=\"action\" id=\"talk\" value=\"3\" onclick=\"currAction=3\"/>Parla con/di</td>";
	html += "<td><a href=\"#\" onclick=\"handleActionOn('inventario')\">Inventario</a></td>";
	html += "<td><a href=\"#\" onclick=\"handleActionOn('stanza')\">Stanza</a></td>";
	html += "<td><a href=\"#\" onclick=\"window.open('aiuto.html')\">Aiuto</a></td>";
	html += "</tr>";
	html += "</table>";
	html += "<hr/>";
	html += "<div id=\"text\"></div>";
	html += "</blockquote>";
	document.body.innerHTML = html;
	document.title = title;
	handleActionOn("stanza");
}

/*
 * myEscape serve per impedire che le parole-entit contenute
 * nella stringa di input vengano sostituite con il loro
 * link.
 */
function myEscape(text) {
	var i;
	var length = text.length;
	var res = "";
	for (i = 0; i < length; i++) {
		res += "&#"+text.charCodeAt(i)+";";
	}
	return res;
}

/*
 * Costruisce un paragrafo comprensivo di link "continua".
 */
function buildParagraph(text, func) {
	var html = "";
	html += "<p>";
	html += "<blockquote>";
	html += text + ln;
	if (func != null) {
		html += "<a href=\"#\" onclick=\"" + func + "\">continua</a>";
	}
	html += "</blockquote>";
	html += "</p>";
	return html;
}

/*
 * Costruisce la risposta ad una azione:
 * 1. Sostituisce ogni parola-entit con il relativo link;
 * 2. esegue i demoni di tutte le entit;
 */
function buildText(text) {
	var i;
	var lentities = entities.length;
	var regex;
	var deamons = "";
	var tmp;
	for (i = 0; i < lentities; i++) {
		regex = new RegExp(entities[i].name, "gi");
		text = text.replace(regex, '<a href="#" onclick="handleActionOn(\''+entities[i].name+'\')">'+entities[i].name+'</a>');
		tmp = entities[i].func(4);
		if (tmp != null) {
			deamons += ln + "<i>" + tmp + "</i>";
		}
	}
	var html = "";
	html += text;
	html += deamons;
	html += "<hr/>";
	return html;
}

/*
 * Dato il nome di un'entit la cerca
 * all'interno del relativo array.
 */
function searchEntity(name) {
	var i;
	var lentities = entities.length;
	for (i = 0; i < lentities; i++) {
		if (entities[i].name == name) {
			return entities[i];
		}
	}
	return null;
}

/*
 * Esegue l'azione corrente sull'entit
 * specificata dall'utente e ne ritorna
 * il risultato.
 */
function handleActionOn(word) {
	var text = document.getElementById('text');
	var div = document.createElement('div');
	div.id = "turn" + turn;
	var out = searchEntity(word).func(currAction);
	if (gameOver) {
		outro(1);
	} else {
		div.innerHTML = buildText(out);
		if (text.firstChild != null) {
			text.insertBefore(div, text.firstChild);
		} else {
			text.appendChild(div);
		}
		turn++;
	}
}
